'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.bp = exports.withBreakpoints = exports.withResize = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _resizeObserverPolyfill = require('resize-observer-polyfill');

var _resizeObserverPolyfill2 = _interopRequireDefault(_resizeObserverPolyfill);

var _lodash = require('lodash.mapvalues');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var withResize = exports.withResize = function withResize(Child) {
	return function (_Component) {
		_inherits(WithResize, _Component);

		function WithResize(props) {
			_classCallCheck(this, WithResize);

			var _this = _possibleConstructorReturn(this, (WithResize.__proto__ || Object.getPrototypeOf(WithResize)).call(this, props));

			_this.state = { rect: {} };
			_this.observer = new _resizeObserverPolyfill2.default(function (entries) {
				_this.setState({ rect: entries[0].contentRect });
			});
			return _this;
		}

		_createClass(WithResize, [{
			key: 'componentDidMount',
			value: function componentDidMount() {
				this.wrapper = (0, _reactDom.findDOMNode)(this);
				if (this.wrapper) {
					this.observer.observe(this.wrapper);
				}
			}
		}, {
			key: 'componentWillUnmount',
			value: function componentWillUnmount() {
				this.observer.unobserve(this.wrapper);
			}
		}, {
			key: 'render',
			value: function render() {
				return _react2.default.createElement(Child, _extends({}, this.props, { rect: this.state.rect }));
			}
		}]);

		return WithResize;
	}(_react.Component);
};

var withBreakpoints = exports.withBreakpoints = function withBreakpoints(breakpoints) {
	return function (Child) {
		return withResize(function (props) {
			return _react2.default.createElement(Child, _extends({}, props, {
				breakpoints: (0, _lodash2.default)(breakpoints, function (breakpoint) {
					return breakpoint(props.rect);
				}) }));
		});
	};
};

var bp = exports.bp = function bp(fallback, values) {
	return function (_ref) {
		var breakpoints = _ref.breakpoints;

		for (var name in values) {
			if (breakpoints[name]) return values[name];
		}return fallback;
	};
};
